<?php
/*
Sistem Inventory Control dan Sales Tracking - by Chandra
Modification history 15 Agustus 2020
Prod list dan sales list, 
sudah terdapat connection dari new sale ke prodlist, 
dan sebaliknya akan ada update dari perubahan status produksi ke sale list.


Versi 1.03 Inventory
Modifikasi berjalan 15 Agustus utk menambahkan:
- inve_list utk inventory pada ccsalesmaster <-- master inventory.
- invemaintain utk edit rincian salesmaster. 
- tabel ccsalesmaster ditambahkan BOM berupa JSON utk maintain standar penggunaan material.

*/
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

class CCauthController extends JControllerLegacy // cc: change component
{
	public function display($cachable = false, $urlparams = array())
	{
		$cachable = true;
		$task = $this->input->getCmd('view', 'display');
		switch ($task){
			case 'logon':
				$this->input->set('view', 'logon');
				break;
			case 'home':
				$this->input->set('view', 'home');
				break;
			case 'chgpas':
				$this->input->set('view', 'chgpas');
				break;					
			case 'new_sale':
				$this->input->set('view', 'new_sale');
				break;					
			case 'new_prod':
				$this->input->set('view', 'new_prod');
				break;
			case 'sale_list':
				$this->input->set('view', 'sale_list');
				break;					
			case 'prod_list':
				$this->input->set('view', 'prod_list');
				break;	
			case 'proddetail':
				$this->input->set('view', 'proddetail');
				break;		
			case 'produpdate':
				$this->input->set('view', 'produpdate');
				break;						
			case 'siap_kirim':
				$this->input->set('view', 'siap_kirim');
				break;					
			case 'kirim_fwd':
				$this->input->set('view', 'kirim_fwd');
				break;					
			case 'konfirmasi':
				$this->input->set('view', 'konfirmasi');
				break;

//************				Versi 1.03 Inventory
			case 'inve_list':
				$this->input->set('view', 'inve_list');
				break;
			case 'stock_list':
				$this->input->set('view', 'stock_list');
				break;
			case 'invemaintain':
				$this->input->set('view', 'invemaintain');
				break;
			case 'new_inve':
				$this->input->set('view', 'new_inve');
				break;



//************				Versi 1.03 Inventory

			default: 
				$this->input->set('view', 'logon');
				break;
		}
		parent::display($cachable = false, $urlparams = false);
	}
	
	public function menu_redirect()
	{
		
		$jinput = JFACTORY::getApplication()->input;
		$redirect =	$this->sanitizeInput($jinput->get('redirect','','string'));
		$skey =	$this->sanitizeInput($jinput->get('skey','','string'));
		$uscode = $this->sanitizeInput($jinput->get('uscode','','string'));
		
		switch ($redirect){
			case '':
				break;
			case 'chgpas':
				$viewlink = 'chgpas';
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey);		
			break;			
			case 'new_sale':
				$viewlink = 'new_sale';
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey);						
			break;
			case 'new_prod':
				$viewlink = 'new_prod';
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey);						
			break;	
			case 'sale_list':
				$viewlink = 'sale_list';
				$month = $this->sanitizeInput($jinput->get('month','','string')); //get salelist
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey.'&month='.$month);		
				break;	
				
			case 'prod_list':
				$viewlink = 'prod_list';
				$month = $this->sanitizeInput($jinput->get('month','','string')); //get salelist
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey.'&month='.$month);		
				break;
				
			case 'proddetail':
				$viewlink = 'produpdate';
				$id = $this->sanitizeInput($jinput->get('id','','string')); //get salelist
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey.'&id='.$id);		
				break;
				
			case 'produpdate':
				$viewlink = 'produpdate';
				$id = $this->sanitizeInput($jinput->get('id','','string')); //get salelist
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey.'&id='.$id);		
				break;
				
			case 'siap_kirim':
				$viewlink = 'siap_kirim';
				$salesid = $this->sanitizeInput($jinput->get('salesid','','string')); //get salesid
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey.'&salesid='.$salesid);		
				break;					
				
			case 'kirim_fwd':
				$viewlink = 'kirim_fwd';
				$salesid = $this->sanitizeInput($jinput->get('salesid','','string')); //get salesid
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey.'&salesid='.$salesid);		
				break;					
				
			case 'konfirmasi':
				$viewlink = 'konfirmasi';
				$salesid = $this->sanitizeInput($jinput->get('salesid','','string')); //get salesid
				//$salesid = $jinput->get('salesid','','string'); //get salesid
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey.'&salesid='.$salesid);		
				break;

			//************				Versi 1.03 Inventory
			
			case 'inve_list':
				$viewlink = 'inve_list';
	//			$salesid = $this->sanitizeInput($jinput->get('salesid','','string')); 
				//$salesid = $jinput->get('salesid','','string'); //get salesid
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey);		
				break;
			case 'stock_list':
				$viewlink = 'stock_list';
	//			$salesid = $this->sanitizeInput($jinput->get('salesid','','string')); 
				//$salesid = $jinput->get('salesid','','string'); //get salesid
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey);		
				break;	
			case 'invemaintain':
				$viewlink = 'invemaintain';
				$id = $this->sanitizeInput($jinput->get('id','','string')); //get salesid
				//$salesid = $jinput->get('salesid','','string'); //get salesid
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey.'&id='.$id);		
				break;
			case 'new_inve':
				$viewlink = 'new_inve';
				$salesid = $this->sanitizeInput($jinput->get('salesid','','string')); //get salesid
				//$salesid = $jinput->get('salesid','','string'); //get salesid
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey.'&salesid='.$salesid);		
				break;

			
			//************				Versi 1.03 Inventory
			case 'logon':
				$viewlink = 'logon';
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink);		
				break;	
				
			default: 
				break;
		}

		if (isset($viewlink)){
		$mainframe = JFactory::getApplication();
		$mainframe->redirect($link);
		}
		else{
		$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view=logon');	
		$message = "menu not found";
		}
		$mainframe = JFactory::getApplication();
		$mainframe->redirect($link,$message);
	}
	
	
//For action validations
	public function getUsername($skey) {
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName('a.usname')); //change field
		$query->from($db->quoteName('#__ccauthsession', 'a')); // change when change table
		$query->where($db->quoteName('a.passwrd') .' = '.$db->quote($skey));//
		$db->setQuery($query);
		$result = $db->loadResult(); //single data query		//authority check
		return $result;
	}

	public function checkAuth($priv_req) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$skey = $jinput->get('skey','','string'); //default page is empty.
		$uscode = $jinput->get('uscode','','string'); //default page is empty.
			
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName('a.uscode')); //change field
		$query->from($db->quoteName('#__ccauthsession', 'a')); // change when change table
		$query->join('RIGHT', $db->quoteName('#__ccauthlist', 'b') . ' ON (' . $db->quoteName('a.uscode') . ' = ' . $db->quoteName('b.uscode') . ')');
		// here is the matching criteria:  
		$query->where($db->quoteName('a.passwrd') .' = '.$db->quote($skey));// $db->quote($skey));
		$query->where($db->quoteName('b.priv') . ' = '. $db->quote($priv_req));//this is the privilege
		$query->where($db->quoteName('b.uscode') . ' = '. $db->quote($uscode));//this is the privilege
		$db->setQuery($query);
		$results = $db->loadResult(); //single data query
	
		if($results!=""){
			$valid = 1;
			}
			else {
			$valid = 0;
			}
		return $valid;
	}
	
	public function sanitizeInput($data) 
	{
	  $data = trim($data);
	  $data = stripslashes($data);
	  $data = htmlspecialchars($data);
	  return $data;
	}
	
	public function validateCompare($data="", $validData = array())
	{
		//This function to compare a string against valid data in arrays.
		$data = $this->sanitizeInput($data);
		//set default first
		$result = "";// set default result to first valid data if not found
		//compare, if found override result
		foreach ($validData as $testdata){
			if($testdata == $data){				
				$result = $data; //override result
			}
		}
		return $result;
	}


	public function getColumn($select, $table, $where="", $ins="", $ordering="", $by="") {
		// This function is to get eligible items as arrays.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName($select)); //change field
		$query->from($db->quoteName($table)); // change when change table
		// here is the matching criteria:  
	 	if($where!=""){
			$query->where($db->quoteName($where) . ' = '. $db->quote($ins));
		}
	 	if($ordering!=""){
			$query->order($db->quote($ordering.$by));
		}
		$db->setQuery($query);
		$results = $db->loadColumn();
		
		return $results;
	}

	public function getCuid() {
		// This function is to get eligible items as arrays.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName('cuid')); //change field
		$query->from($db->quoteName('#__cccust')); // change when change table
		// here is the matching criteria:  
		$query->where($db->quoteName('status') . ' = '. $db->quote('1'));
		 
		$db->setQuery($query);
		$results = $db->loadColumn();
		
		return $results;
	}
	
	public function getValue($field, $table, $where, $value, $ordering="", $by="")
	{
		$db = JFactory::getDbo();
		$query = $db
			->getQuery(true)
			->select($field)
			->from($db->quoteName($table));
			if($where !=""){
			$query->where($db->quoteName($where) . " = " . $db->quote($value));
			}
			if($ordering!=""){
			$query->order($db->quoteName($ordering) . $by);
			}
		$db->setQuery($query);
		return $db->loadResult();
	}
	
	public function getValue_for_update($field, $table, $where, $value)
	{
		$db = JFactory::getDbo();
		$query = $db
		->getQuery(true)
		->select($field)
		->from($db->quoteName($table))
		->where($db->quoteName($where) . " = " . $db->quote($value));

		$db->setQuery($query);
		return $db->loadResult();
	}
	
	public function getColumn($data, $table, $criteria="", $value="") {
		// This function is to get eligible items as arrays.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName($data));
		$query->from($db->quoteName($table));
		// here is the matching criteria:  
		if($criteria!=""){
		$query->where($db->quoteName($criteria) . ' = '. $db->quote($value));
		}
		$db->setQuery($query);
		$results = $db->loadColumn();
		return $results;
	}
	
	function updateThing($field, $data, $table, $criteria1, $value1, $criteria2, $value2){
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);

		// Fields to update.
		$fields = 
		$db->quoteName($field) . ' = ' . $db->quote($data); // field name and data

		// Conditions for which records should be updated.
		$conditions = array(
		$db->quoteName($criteria1) . ' = '. $db->quote($value1), //$criteria1 and value1 matching test
		$db->quoteName($criteria2) . ' = '. $db->quote($value2)); // criteria2 and value 2 matching test

		$query->update($db->quoteName($table))->set($fields)->where($conditions);  // table name 
		$db->setQuery($query);
		$result = $db->execute();
	}

function updateOneRow($object, $table, $primary){
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);

		// Fields to update.
		$many_fields = "";
		if(!empty($object)){			
			//$query->update($db->quoteName($table))->set($many_fields)->where($conditions);  // table name 
			$db->updateObject($table, $object, $primary);
			//$result = $db->execute();
		}
	}
	
	public function getInid($active) {
		// This function is to get eligible items as arrays.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName('itemcode')); //change field
		$query->from($db->quoteName('#__ccsalesmaster')); // change when change table
		// check if only active items are checked
		if($active="active"){
		$query->where($db->quoteName('status') . ' = '. $db->quote('1'));
		} else{
			// no where
		}
		
		$db->setQuery($query);
		$results = $db->loadColumn();
		return $results;
	}
	
	public function insertRow($fields, $datas, $table){
		
		/* HOW TO USE
		//to define data before insertion
		$fields = array('user_id', 'profile_key', 'profile_value', 'ordering');
		$datas = array();
		$table = '#__ccsalestrail';
		//to use
		$this->insertRows($fields,$datas,$table);
		*/
				
		$db = JFactory::getDbo();

		// Create a new query object.
		$query = $db->getQuery(true);

		// Insert values.
		$values = array();
		
		foreach($datas as $data){
			if (is_int($data)== 1){
				$values[] = $data ;
			}
			else{
				$values[] = $db->quote($data) ;
			}
		}


		// Prepare the insert query.
		$query
			->insert($db->quoteName($table))
			->columns($db->quoteName($fields))
			->values(implode(',', $values));

		// Set the query using our newly populated query object and execute it.
		$db->setQuery($query);
		$db->execute();
		
	}
	

function change_proddetail()
{
	$checkauth = $this->checkAuth('prodchange');//authority to action.

	if($checkauth == 0){
		echo 'you are not authorized to do this action';	
		return;
	} else {
		// get all the data and validate things
		$jinput = JFACTORY::getApplication()->input;

		$skey = $this->sanitizeInput($jinput->get('skey','','string'));
		$uscode = $this->sanitizeInput($jinput->get('uscode','','string'));
		$batch_id = $this->sanitizeInput($jinput->get('batch_id','','INT'));
		$saleid = $this->sanitizeInput($jinput->get('saleid','','INT'));
		$ponumber = $this->sanitizeInput($jinput->get('ponumber','','string'));
		$picname = $this->sanitizeInput($jinput->get('picname','','string'));
		//$approver = $this->sanitizeInput($jinput->get('approver','','string'));
		$productname = $this->sanitizeInput($jinput->get('productname','','string'));
		$target = $this->sanitizeInput($jinput->get('target','','string'));
		$startdate = $this->sanitizeInput($jinput->get('startdate','','date'));
		$duedate = $this->sanitizeInput($jinput->get('duedate','','date'));
		$status = $this->sanitizeInput($jinput->get('status','','INT'));
		$remark = $this->sanitizeInput($jinput->get('remark','','string'));
		$connect_sales = $this->sanitizeInput($jinput->get('connect_sales',0,'INT'));

		
		$validate = 1; //default success
		$errmessage = "Terjadi kesalahan: ";
		//validate all fields should be matching
		$pic_id = explode("-",$picname);
		//$approver_id = explode("-",$approver);
		$product_id = explode("-",$productname);

		
		$check_batch_id = $this->validateCompare($batch_id, $this->getColumn('id', '#__ccprodlist', 'published', 1));
		$check_picname = $this->validateCompare($pic_id[0], $this->getColumn('alias', '#__ccempl', 'status', 1));
		//$check_approver = $this->validateCompare($approver_id[0], $this->getColumn('alias', '#__ccauth', 'status', 1));
		$check_productname = $this->validateCompare($product_id[0], $this->getColumn('itemcode', '#__ccsalesmaster', 'status', 1));
		$check_ponumber = $this->validateCompare($ponumber, $this->getColumn('ponumber', '#__ccsales', 'status', 1));

		if($check_batch_id =="" || $check_picname == "" || $check_productname == "" ){
			$validate = 0;
			$errmessage .= " data tidak cocok." . "batch: ". $check_batch_id . "pic: ".$check_picname . "productname: ".$check_productname.
			"PO Number: ".$check_ponumber ;
		}
		
		if($connect_sales == 1){
			//get sales ID to validate sale ID
			$salesID = $this->getValue('salesid', '#__ccsales', 'ponumber', $ponumber);
			$check_saleid = $this->validateCompare($saleid, $this->getColumn('id', '#__ccsalesdetail', 'salesid', $salesID));

			if($check_ponumber == "" || $check_saleid =="") 
			{
				$validate = 0;
				$errmessage .=  " PO atau nomor Sale ID tidak ditemukan, atau PO dan Sale ID tidak cocok. ";
			}
			
			if($saleid < 1){
			$validate = 0;
			$errmessage .= " sale id tidak diisi, nol atau negatif.";
			}		
		}
		
		
		if(strlen($check_picname) > 25 || strlen($check_productname) > 35 || strlen($remark) > 254 || strlen($ponumber) > 35){
			$validate = 0;
			$errmessage .= " panjang input tidak sesuai.";
		}
		
		//checking the INTEGERS
		$target = str_replace(",","",$target);
		if($target < 1){
			$validate = 0;
			$errmessage .= " target nol atau negatif.";
		}

		$check_status = $this->validateCompare($status, array(0,1,8));
		$check_connect_sales = $this->validateCompare($connect_sales, array(0,1));

		if(strlen($status) > 2 || $check_status == "" || $check_connect_sales =="" ){
			$validate = 0;
			$errmessage .= " status error.";
		}		

		//checking the DATES
		$check_startdate = $this->validateDate($startdate, 'Y-m-d');
		$check_duedate = $this->validateDate($duedate, 'Y-m-d');
		
		if($check_startdate == "" || $check_duedate == "" ){
			$validate = 0;
			$message .= " tanggal error.";
		}		
		
		//If success, update the data entry
		if($validate == 1){
			
			//prepare the data
			$data = new stdClass();
			$data->pic = $check_picname;
			$data->approver = $this->getValue('alias','#__ccauthsession', 'passwrd', $skey, 'id', ' ASC');
			$data->itemcode = $check_productname;
			$data->target = $target;
			$data->startdate = $startdate;
			$data->duedate = $duedate;
			$data->status = $status;			
			$data->ponumber = $ponumber;
			$data->saleid = $saleid;
			$data->connect = $connect_sales;

			if($data->status == 1 || $data->status == 8){
				$data->published = 0;	
				
				//update to sales status
				$sales = new stdClass();
				$sales->status = $status;
				$sales->id = $saleid;
				$this->updateOneRow($sales, '#__ccsalesdetail', 'id');

			}
			$data->remark = $remark;
			$data->id = $check_batch_id;			
			//update the data
	//		$this->updateThings($fields, $data, "#__ccprodlist", 'id', $check_batch_id);
			
			$this->updateOneRow($data, '#__ccprodlist', 'id');
			//message
			$message = "Pengubahan berhasil";
			$link = JRoute::_('index.php?option=com_ccauth&view=proddetail&skey='.$skey.'&uscode='.$uscode.'&id='.$batch_id);
		} else{
			$message = $errmessage;
			$link = JRoute::_('index.php?option=com_ccauth&view=proddetail&skey='.$skey.'&uscode='.$uscode.'&id='.$batch_id);
		}
	}	
	$mainframe = JFactory::getApplication();	
	$mainframe->redirect($link, $message);
}

	
		
		
}