<?php

defined('_JEXEC') or die('Restricted access');

class CCjournalModelReports extends JModelItem //change component
{
	protected $messages;

	public function getTable($type = 'CCjournal', $prefix = 'CCjournalTable', $config = array()) //cc notes: prefix can be changed consistent with file ccworld content. Type should consistent with both class name and file name.
	{
		return JTable::getInstance($type, $prefix, $config);
	}

	public function getAuth($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$skey = $jinput->get('skey','','string'); //default page is empty.
		$uscode = $jinput->get('uscode','','string'); //default page is empty.
		$priv_req = 'authall'; //required privilege
				
		//validation process
		$skey = $this->sanitizeInput($skey);
			
		// query if found
			function getUsid($skey, $uscode, $priv_req) {
	
					$db = JFactory::getDbo();
					$query = $db->getQuery(true);
					$query->select($db->quoteName('a.uscode')); //change field
					$query->from($db->quoteName('#__ccauthsession', 'a')); // change when change table
					$query->join('RIGHT', $db->quoteName('#__ccauthlist', 'b') . ' ON (' . $db->quoteName('a.uscode') . ' = ' . $db->quoteName('b.uscode') . ')');
					// here is the matching criteria:  
					$query->where($db->quoteName('passwrd') . ' = '. $db->quote($skey));
					$query->where($db->quoteName('b.priv') . ' = '. $db->quote($priv_req));//this is the privilege
					$query->where($db->quoteName('b.uscode') . ' = '. $db->quote($uscode));//this is the privilege
					$db->setQuery($query);
					$results = $db->loadResult(); //single data query
					
					return $results;
			}
			
		$check = getUsid($skey, $uscode, $priv_req);
		
		if($check!=""){
			$valid = 1;
			}
			else {
			$valid = 0;
			}
			
		return $valid;
	}

	
	public function getSkey($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('skey','','string'); //default page is empty.
		//validation process
		$result = $this->sanitizeInput($result);
		return $result;		
	}

//get current page.
	public function getPage($id = 1) { //no change
		$jinput = JFACTORY::getApplication()->input;
		$page = $jinput->get('page',1,'int'); //default page is 1.
				
		//validation process
		$page = $this->sanitizeInput($page);
		$itemscount = $this->getItemscount();
		$itemsperpage = $this->getItemsperpage();
			
		// get from xml
		$maxpage = round(($itemscount / $itemsperpage) + 0.5,0,PHP_ROUND_HALF_DOWN);
		
		if($page < 1){$page = 1;}//default page is 1.
		if($page > $maxpage){$page = $maxpage;} //max is maxpage
		return $page;
	}

	
//get current maximum paging per screen.
	public function getMaxpaging($id = 1){ //no change	
		// get from xml
		$app = JFactory::getApplication();
		$params = $app->getParams();
		$maxpaging = $params->get('maxpage', 10);
		return $maxpaging;			
	}

//count number of comments matching criteria, so it can be calculated for paging.
	public function getItemscount($id = 1) {
		// This function is to count eligible items. Results are returned to get the max page.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName('a.glid')); //change field
		$query->from($db->quoteName('#__ccworldgl', 'a')); // change when change table
		//$query->join('INNER', $db->quoteName('#__ccjourntrx', 'b') . ' ON (' . $db->quoteName('b.jnid') . ' = ' . $db->quoteName('a.jnid') . ')');
		// here is the matching criteria:  
		$query->where($db->quoteName('a.status') . ' = '. $db->quote('1'));
		 
		$db->setQuery($query);
		$query = $db->loadObjectList();
		$itemscount = count($query);
		
		return $itemscount;
		}
			
//get configuration of items per page. Get it from database as default, get it from menu items when defined.
	public function getItemsperpage(){
	
		// get from xml configuration 
		$app = JFactory::getApplication();
		$params = $app->getParams();
		$itemsperpage = $params->get('maxitem',10);
		
		return $itemsperpage;
		}

	// now get the comments to be displayed, according to matching criteria.
	public function sanitizeInput($input){
	$input = trim($input);
	$input = stripslashes($input);
	$input = htmlspecialchars($input);
	return $input;
	}
	
	public function validateCompare($data, $validData){
	//This function to compare a string against valid data in arrays.
	$data = $this->sanitizeInput($data);
	//set default first
	$result = $validData[0];// set default result to first valid data if not found
	//compare, if found override result
		foreach ($validData as $testdata){
			if($testdata == $data ){				
			$result = $data; //override result
			}
		}
	return $result;
	}
	
	public function getOrdering($id = 1)
		{	
		
			$app = JFactory::getApplication();
			$params = $app->getParams();
			$order_default = $app->input->get('limit', $params->get('orderby_sec', 'glid'), 'uint'); //change field
			
			//new: override if set by user. dont forget to validate
			$jinput = JFACTORY::getApplication()->input;
			$order_type = $jinput->get('orderby',$order_default); //default get parameter

			$order_submit = $jinput->get('ordering_submit'); 
			if (isset($order_submit))
			{
			$order_type = $order_submit;
			}
			//validate $order_submit
			//set true data
			$validDataOrdering = ['id','rid','bal','rbal']; //glid and nominal
						
			$order_type = $this->validateCompare($order_type, $validDataOrdering);
						
			return $order_type;
		}
		
	public function getMsg($id = 1)
		{
			
		if (!isset($this->article[$id]))
		{			
			$itemsperpage = $this->getItemsperpage();
			
			// get from xml
			$jinput = JFACTORY::getApplication()->input;

			$page = $this->getPage();//get current page
			
			$skipitems = $itemsperpage * ($page - 1);

			//get the ordering
			$app = JFactory::getApplication();
			$params = $app->getParams();
			$order_type = $this->getOrdering();
			
			switch ($order_type){
			case 'bal':
				$ordering = 'c.total ASC'; //later to work on this
				break;
			case 'rbal':
				$ordering = 'c.total DESC'; //later to work on this
				break;
			case 'id':
				$ordering = 'd.glid ASC';
				break;
			case 'rid':
				$ordering = 'd.glid DESC';
				break;
			default: 
				$ordering = 'd.glid ASC';
				break;
			}

			// 1. FIRST STEP ******************** UPDATE ALL THE ENTRIES ACCORDING TO JOURNAL STATUS******
			
			$db = JFactory::getDbo();
			
			$query = $db->getQuery(true);		
			$query->select('a.id, a.status, b.status as statusreal'); //id is the identifier to be replaced next
			//$query->select('b.status as statusreal');
			$query->from($db->quoteName('#__ccjourn', 'a'));//change database to be refreshed
			$query->join('INNER', $db->quoteName('#__ccjourntrx', 'b') . ' ON (' . $db->quoteName('b.jnid') . ' = ' . $db->quoteName('a.jnid') . ')');
			
			$query->where($db->quoteName('b.status') . ' <> '. $db->quoteName('a.status'));
	
			$db->setQuery($query);
			 
			$updates = $db->loadObjectList();	
			
			// 2. NOw CHECK RESULTS THEN UPDATE THE STATUS
			//check if result exist
			$count = count($updates);
			if ($count == 0){
			}
			else {
				
				foreach($updates as $entry){
				$update = $db->getQuery(true);
				// Fields to update.
				$field = 
					$db->quoteName('status') . ' = ' . $entry->statusreal;

				// Conditions for which records should be updated.
				$condition = 
					$db->quoteName('id') . ' = ' .$entry->id; 
								
				$update->update($db->quoteName('#__ccjourn'))->set($field)->where($condition);
				//$result = JFactory::getDbo()->updateObject('#__ccjourn',$data); //cc change database

				$db->setQuery($update);

				$result = $db->execute();
				}
			}
			// 3. FINALLY, DISPLAY THE REPORTS BASED ON UPDATED ENTRIES
			
			
			// new 22 April 2019 setting up the dates for cut-off.
			$jinput = JFACTORY::getApplication()->input;
			$cutoffdate = $jinput->get('cutoffdate','99991231'); //default no date limit
			if ($cutoffdate == ''){
				$cutoffdate = '99991231';
				}
			$cutoffdate = $this->sanitizeInput($cutoffdate);
			//default first
			//$cutoffdate = '20150606';
			
			$debets = $db->getQuery(true);
			$credits = $db->getQuery(true);
			$complement1 = $db->getQuery(true);
			$complement2 = $db->getQuery(true);		
			
			$glcode1 = $db->getQuery(true);
			
			$glcode2 = $db->getQuery(true);
			$netdebets = $db->getQuery(true);
			$trialbalance = $db->getQuery(true);
			$debets
			->select('b.glid, a.dbcr, SUM(a.nominal) as total')//id is the identifier to be replaced next
			->from($db->quoteName('#__ccjourn', 'a'))//change database to be refreshed
			->join('RIGHT', $db->quoteName('#__ccworldgl', 'b') . ' ON (' . $db->quoteName('b.glid') . ' = ' . $db->quoteName('a.glid') . ')')
			->where($db->quoteName('a.status') . ' = 1') //active only
			->where($db->quoteName('a.dbcr') . ' = 1')//debet only
			->where($db->quoteName('a.jndate') .' <= '. $cutoffdate) // new with cutoff
			->group('a.glid ASC');//groupby glid

			$credits
			->select('b.glid, a.dbcr, SUM(a.nominal) as total')//id is the identifier to be replaced next
			->from($db->quoteName('#__ccjourn', 'a'))//change database to be refreshed
			->join('RIGHT', $db->quoteName('#__ccworldgl', 'b') . ' ON (' . $db->quoteName('b.glid') . ' = ' . $db->quoteName('a.glid') . ')')
			->where($db->quoteName('a.status') . ' = 1') //active only
			->where($db->quoteName('a.dbcr') . ' = 2')//debet only
			->where($db->quoteName('a.jndate') .' <= '. $cutoffdate) // new with cutoff
			->group('a.glid ASC');//groupby glid
			
			$complement1
			->select('d.glid, d.glname, c.dbcr, c.total')
			->from( '('.$debets.') as c')
			->join('RIGHT', $db->quoteName('#__ccworldgl', 'd') . ' ON (' . $db->quoteName('c.glid') . ' = ' . $db->quoteName('d.glid') . ')')
			//->order('d.glid ASC');
			->order($ordering);

			$complement2
			->select('d.glid, d.glname, c.dbcr, c.total')
			->from( '('.$credits.') as c')
			->join('RIGHT', $db->quoteName('#__ccworldgl', 'd') . ' ON (' . $db->quoteName('c.glid') . ' = ' . $db->quoteName('d.glid') . ')')
			//->order('d.glid ASC');
			->order($ordering);
			
			$results1 = $db->setQuery($complement1)->loadObjectList();
			$results2 = $db->setQuery($complement2)->loadObjectList();
			$results[0] = $results1;
			$results[1] = $results2;
			
			$glcode1
			->select('b.glid, a.dbcr, b.glcode') //id is the identifier to be replaced next
			->select (
			"CASE WHEN " . $db->quoteName('a.dbcr') ." = 1" .
			" THEN " . $db->quoteName('a.nominal') .
			" ELSE " . $db->quoteName('a.nominal') . "* -1 " .
			" END AS " . $db->quoteName ('nomin'))
			
			->from($db->quoteName('#__ccjourn', 'a'))//change database to be refreshed
			->join('RIGHT', $db->quoteName('#__ccworldgl', 'b') . ' ON (' . $db->quoteName('b.glid') . ' = ' . $db->quoteName('a.glid') . ')')
			->where($db->quoteName('a.status') . ' = 1 AND '. $db->quoteName('b.glcode') .' = 1 AND '. $db->quoteName('a.jndate') .' <= '. $cutoffdate) 
			->orWhere($db->quoteName('a.status') . ' = 1 AND ' . $db->quoteName('b.glcode').' = 5 AND '. $db->quoteName('a.jndate') .' <= '. $cutoffdate);//debet only
			
			
			$glcode2
			->select('b.glid, a.dbcr, b.glcode') //id is the identifier to be replaced next
			->select (
			"CASE WHEN " . $db->quoteName('a.dbcr') ." = 2" .
			" THEN " . $db->quoteName('a.nominal') .
			" ELSE " . $db->quoteName('a.nominal') . "* -1 " .
			" END AS " . $db->quoteName ('nomin'))
			
			->from($db->quoteName('#__ccjourn', 'a'))//change database to be refreshed
			->join('RIGHT', $db->quoteName('#__ccworldgl', 'b') . ' ON (' . $db->quoteName('b.glid') . ' = ' . $db->quoteName('a.glid') . ')')
//			->where($db->quoteName('a.status') . ' = 1') //active only
//			->where($db->quoteName('b.glcode') . ' = 2 OR ' . $db->quoteName('b.glcode').' = 3 OR '. $db->quoteName('b.glcode').' = 4' );//credits only
			
			->where($db->quoteName('a.status') . ' = 1 AND '. $db->quoteName('b.glcode') .' = 2 AND '. $db->quoteName('a.jndate') .' <= '. $cutoffdate)  
			->orWhere($db->quoteName('a.status') . ' = 1 AND ' . $db->quoteName('b.glcode').' = 3 AND '. $db->quoteName('a.jndate') .' <= ' . $cutoffdate)
			->orWhere($db->quoteName('a.status') . ' = 1 AND ' . $db->quoteName('b.glcode').' = 4 AND '. $db->quoteName('a.jndate') .' <= '. $cutoffdate);
			
			$netdebets // only GL with numbers is shown. 
			->select('c.glid, c.dbcr, c.glcode, d.glname, SUM(nomin) as nomin')
			->from( '('.$glcode1->unionAll($glcode2).') as c')
			->join('RIGHT', $db->quoteName('#__ccworldgl', 'd') . ' ON (' . $db->quoteName('d.glid') . ' = ' . $db->quoteName('c.glid') . ')')
			->group('c.glid ASC');//groupby glid
			
			$trialbalance // all GL is shown 
			->select('d.glid, c.dbcr, d.glcode, d.glname, nomin')
			->from( '('.$netdebets.') as c')
			->join('RIGHT', $db->quoteName('#__ccworldgl', 'd') . ' ON (' . $db->quoteName('c.glid') . ' = ' . $db->quoteName('d.glid') . ')')
			->order('d.glid');
			
			
		//$results3 = $db->setQuery($trialbalance)->loadObjectList();
		$results3 = $db->setQuery($trialbalance)->loadObjectList();
		
		$results[2] = $results3;
			
		}
		return $results;
	}
	

	
	
	
	
}