<?php
/**
 Purreceive is used to receive purchased materials once ordered in the system.
 The view should display warehouses available to the users to receive ordered goods.
 If no warehouse assigned then show info to user that no warehouse available to manage, or you dont have the authority.
 
 */
 
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

class CCauthModelCollectlist extends JModelItem
{
	protected $messages;

/*************************  COMMON FUNCTIONS *****************************/

	public function sanitizeInput($input){
		$input = trim($input);
		$input = stripslashes($input);
		$input = htmlspecialchars($input);
		return $input;
		}
		
	public function validateCompare($data, $validData){
		//This function to compare a string against valid data in arrays.
		$data = $this->sanitizeInput($data);
		//set default first
		$result = $validData[0];// set default result to first valid data if not found
		//compare, if found override result
			foreach ($validData as $testdata){
				if($testdata == $data ){				
				$result = $data; //override result
				}
			}
		return $result;
		}

/********************  AUTHORITY CHECK FUNCTIONS *************************/


	public function getAuth() 
	{	
		$skey 	= $this->getSkey(); 
		$uscode = $this->getUscode(); 
		$priv_req = 'authall'; //required privilege
		$check = $this->getInstance('Home', 'CCauthModel')->home_check_priv($skey, $uscode, $priv_req); // this refer function in the home model.
		return $check;
	}

/*****************  GETTING THE DATA TO DETERMINE HOW THE PAGE LOOKS *******************/
	
	public function getSkey($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('skey','','string'); //default page is empty.
		return $this->sanitizeInput($result);	
	}
	
	public function getUscode($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('uscode','','string'); //default page is empty. $this->sanitizeInput($result);
		return $this->sanitizeInput($result);	
	}
	
	public function getUsid($id = 1) {		//authority check
		//$usid = $this->getSomeRows('usid', '#__ccauthsession', 'passwrd',$this->getUscode);
		//validate if found
		
		//return $result;	
		$skey = $this->getSkey();
		//$uscode = "e2ef7b61bb37ac19c020f5100ed6df202bec0424";
		$db = JFactory::getDbo();
		$query = $db
		->getQuery(true)
		->select('usid')
		->from($db->quoteName('#__ccauthsession')) // change when change table
		->where($db->quoteName('passwrd') . ' = '.$db->quote($skey));
		
		$db->setQuery($query);
		$result = $db->loadResult();
		
		if(empty($skey)){
			return "";
		}
		else{
			return $result;
		}		
	}

	public function getSomeRows($select, $table, $where="", $ins="", $ordering="", $by="") {
		// This function is to get eligible items as arrays.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($select); //array
		$query->from($db->quoteName($table)); // change when change table
		// here is the matching criteria:  
	 	if($where!=""){
			$query->where($db->quoteName($where) . ' = '. $db->quote($ins));
		}
	 	if($ordering!=""){
			$query->order($db->quote($ordering.$by));
		}
		$db->setQuery($query);
		$result = $db->loadObjectList();
		
		return $result;
	}

	public function getMenus($id = 1){
		$valid = $this->getAuth();//authority check
		$uscode = $this->getUscode(); 
		
		if($valid == 1)
		{
			$results = $this->getInstance('Home', 'CCauthModel')->home_get_menus($uscode);
		} else { 
			$results = array(); //return empty array when no menu found for the user.
		}
		return $results;
	}
	////////////// GET LIST OF OPEN PAYMENTS and CLOSED PAYMENTS, based on purcdetail status and ////////////////
	public function getList(){	
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select(array('DISTINCT a.collect_ref','a.customer','a.eligible','a.status', 'a.remark'  ));
		$query->from($db->quoteName('#__ccsale_collect', 'a')); // change when change table

		$query->where($db->quoteName('a.active') . ' = '. $db->quote(1));	

	 	$query->order('a.id DESC');
		
		$db->setQuery($query);
		$result = $db->loadObjectList();
		
		return $result;
	}
	
		public function getPayments(){	
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select(array('a.collect_ref', 'a.customer', 'a.remark','SUM(a.payment) as sum'  )); //array
		$query->from($db->quoteName('#__ccsale_collect_details', 'a')); // change when change table
		$query->group($db->quoteName('a.collect_ref')); // change when change table
	//	//	$query->join('LEFT', $db->quoteName('#__ccpurcdetail', 'b') . ' ON ' . $db->quoteName('a.ref') . ' = ' . $db->quoteName('b.ref'));

		$query->where($db->quoteName('a.active') . ' = '. $db->quote(1));	
	//	$query->where($db->quoteName('a.status') .' = '. $db->quote(2)) ;
	//	$query->where($db->quoteName('a.status') .' = '. $db->quote(1)) ;
	//	$query->orwhere($db->quoteName('a.status') .' = '. $db->quote(3)) ;	

	 	$query->order('a.id DESC');
		
		$db->setQuery($query);
		$result = $db->loadAssocList('collect_ref');
		
		return $result;
	}
	
	////////////// GET Details of Last Payments for user reference -- NO USE ////////////////
	public function getPayment(){	
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select(array('a.ref','a.collect_ref','a.customer','a.payment','a.collect_date','a.eligible','a.remark'  )); //array
		$query->from($db->quoteName('#__ccsale_collect', 'a')); // change when change table

		$query->where($db->quoteName('a.active') . ' = '. $db->quote(1));	
//		$query->where($db->quoteName('a.status') .' = '. $db->quote(2)) ;
//		$query->orwhere($db->quoteName('a.status') .' = '. $db->quote(3)) ;	

	 	$query->order('a.id DESC');
		
		$db->setQuery($query);
		$result = $db->loadObject();
		
		return $result;
	}
		
		////////////// GET Vendors for user selection ////////////////
	public function getVendors(){	
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select(array('a.vendorid','a.name' )); //array
		$query->from($db->quoteName('#__ccpurvendor', 'a')); // change when change table

	//	$query->where($db->quoteName('a.status') . ' = '. $db->quote(1));	
//		$query->where($db->quoteName('a.status') .' = '. $db->quote(2)) ;
//		$query->orwhere($db->quoteName('a.status') .' = '. $db->quote(3)) ;	

	 	$query->order('a.id DESC');
		
		$db->setQuery($query);
		$result = $db->loadObjectList();
		
		return $result;
	}
	
	
	
}