<?php
/**
 *  
 * support: sorting configured in menu items.
 * numbering on item, numbering on page, max item per page, max paging per page.
 */
 
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

class CCauthModelEditWare extends JModelItem
{
	// ************************* Functions to check authority of users
	public function getUsid($passwd, $uscode, $priv_req) {

		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName('a.usid')); //change field
		$query->from($db->quoteName('#__ccauthsession', 'a')); // change when change table
		$query->join('RIGHT', $db->quoteName('#__ccauthlist', 'b') . ' ON (' . $db->quoteName('a.uscode') . ' = ' . $db->quoteName('b.uscode') . ')');
		// here is the matching criteria:  
		$query->where($db->quoteName('passwrd') . ' = '. $db->quote($passwd));
		$query->where($db->quoteName('b.priv') . ' = '. $db->quote($priv_req));//this is the privilege
		$query->where($db->quoteName('b.uscode') . ' = '. $db->quote($uscode));//this is the privilege

		$db->setQuery($query);
		$results = $db->loadResult(); //single data query
		
		return $results;
	}


	//validate the user first
	public function getAuth($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$skey = $jinput->get('skey','','string'); //default page is empty.
		$uscode = $jinput->get('uscode','','string'); //default page is empty.
		$priv_req = 'authall'; //required privilege
				
		//validation process
		$skey = $this->sanitizeInput($skey);
			
		//$check = getUsid($skey, $uscode, $priv_req);
		$check = $this->getUsid($skey, $uscode, $priv_req);
		
		if($check!=""){
			$valid = 1;
			}
			else {
			$valid = 0;
			}
		return $valid;
	}
	//prepare the sessions and user-ID
	
	public function getSkey($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('skey','','string'); //default page is empty.
		//validation process
		$result = $this->sanitizeInput($result);
		return $result;		
	}
	
	public function getUscode($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('uscode','','string'); //default page is empty.
		//validation process
		$result = $this->sanitizeInput($result);
		return $result;		
	}

// ************************* Common functions to support other functions

	public function sanitizeInput($input){
		$input = trim($input);
		$input = stripslashes($input);
		$input = htmlspecialchars($input);
		return $input;
	}
	
	public function validateCompare($data, $validData){
		//This function to compare a string against valid data in arrays.
		$data = $this->sanitizeInput($data);
		//set default first
		$result = $validData[0];// set default result to first valid data if not found
		//compare, if found override result
		foreach ($validData as $testdata){
			if($testdata == $data ){				
			$result = $data; //override result
			}
		}
		return $result;
	}

	public function getValue($field, $table, $where, $value, $ordering, $by)
	{
		$db = JFactory::getDbo();
		$query = $db
			->getQuery(true)
			->select($field)
			->from($db->quoteName($table))
			->where($db->quoteName($where) . " = " . $db->quote($value))
			->order($db->quoteName($ordering) . $by);
		$db->setQuery($query);
		return $db->loadResult();
	}
	
// ************************* functions to show menus

	public function getMenus($id = 1)
		{
		//check authority
		$valid = $this->getAuth();//authority check first
	
		if($valid == 1){
			if (!isset($this->article[$id]))
			{			
		
			// get from xml
			$jinput = JFACTORY::getApplication()->input;

			//get the ordering
			$app = JFactory::getApplication();
			$params = $app->getParams();
			//$order_type = $this->getOrdering();
			$jinput = JFACTORY::getApplication()->input;
			$skey = $jinput->get('skey','','string'); //default page is empty.
			$uscode = $jinput->get('uscode','','string'); //default page is empty.
	
			// Create a new query object.
			
			$db = JFactory::getDbo();
			
			$query = $db->getQuery(true);		
			
			$query->select($db->quoteName('a.uscode'));
			$query->select($db->quoteName('a.priv'));
			$query->select($db->quoteName('a.id'));
			$query->select($db->quoteName('b.link_to_menu'));
			$query->select($db->quoteName('b.menu'));
			$query->select($db->quoteName('b.menu_desc'));
			$query->select($db->quoteName('b.task'));
			$query->select($db->quoteName('b.option_s'));
			$query->from($db->quoteName('#__ccauthlist', 'a')); // change when change table
			$query->join('LEFT', $db->quoteName('#__ccauthmenu', 'b') . ' ON (' . $db->quoteName('a.priv') . ' = ' . $db->quoteName('b.priv') . ')');
			$query->where($db->quoteName('uscode') . ' = '. $db->quote($uscode));
			$query->where($db->quoteName('b.link_to_menu') . ' != ""');
			$query->where($db->quoteName('b.published') . ' = 1'); // only view the menus, not action privileges.

			// Order it by the ordering field.
			$query->order('id ASC');
			$db->setQuery($query);			 
			$results = $db->loadObjectList();	
			}
		}
		if($valid == 0){ //authority check
			$results = array();
		}
		
		return $results;
	}

// ************************* functions for New Inventory

// showing the current inventory from ccsalesmaster, either active or not active

	public function getWare()
		{
			$jinput = JFACTORY::getApplication()->input;
			$id = $this->sanitizeInput($jinput->get('id','','string')); //default page is empty.
			
			$db = JFactory::getDbo();
			$query = $db->getQuery(true);		
			
			$query->select(array('a.enid', 'a.enname', 'a.endesc', 'a.status', 'a.published', 'a.supplier', 'a.customer'));
			$query->from($db->quoteName('#__ccwarehousemaster', 'a')); // change when change table

			$query->where($db->quoteName('enid') . ' = '. $db->quote($id));

			$db->setQuery($query);			 
			$results = $db->loadObject();	
		
		return $results;
	}

// get all existing akses for options.
	public function getAccess()
		{
			$db = JFactory::getDbo();
			$query = $db->getQuery(true);		
			
			$query->select('DISTINCT uscode');
			$query->from($db->quoteName('#__ccauthlist')); // change when change table

			$query->order('uscode ASC');			

			$db->setQuery($query);			 
			$results = $db->loadColumn();	
		
		return $results;
	}
	
}