<?php
/**
 * COMMENTS v.1.0 December 2015
 * to see COMMENTS on CERTAIN ARTICLES.
 * 
 * support: sorting configured in menu items.
 * numbering on item, numbering on page, max item per page, max paging per page.
 */
 
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

class CCauthModelHome extends JModelItem
{
	protected $messages;

	public function getTable($type = 'CCinve', $prefix = 'CcInveTable', $config = array()) //cc notes: prefix can be changed consistent with file ccworld content. Type should consistent with both class name and file name.
	{
		return JTable::getInstance($type, $prefix, $config);
	}



	// function for user-ID, session ID and privilege verification. if true then verified.
	public function compare_privilege($passwd, $uscode, $priv_req) {
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName('a.uscode')); 
		$query->from($db->quoteName('#__ccauthsession', 'a')); 
		$query->join('RIGHT', $db->quoteName('#__ccauthlist', 'b') . ' ON (' . $db->quoteName('a.uscode') . ' = ' . $db->quoteName('b.uscode') . ')');
		// here is the matching criteria:  
		$query->where($db->quoteName('passwrd') . ' = '. $db->quote($passwd));
		$query->where($db->quoteName('b.priv') . ' = '. $db->quote($priv_req));//this is the privilege
		$query->where($db->quoteName('b.uscode') . ' = '. $db->quote($uscode));//this is the privilege

		$db->setQuery($query);
		$results = $db->loadResult(); //single data query
		
		return $results;
	}


//validate the user first
	public function getAuth($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$skey = $jinput->get('skey','','string'); 
		$uscode = $jinput->get('uscode','','string'); 
		$priv_req = 'authall'; //required privilege
				
		$skey = $this->sanitizeInput($skey);
			
		// query if found
		$check = $this->compare_privilege($skey, $uscode, $priv_req);
		
		if($check!=""){
			$valid = 1;
			}
			else {
			$valid = 0;
			}
			
		return $valid;
	}
//prepare the sessions and user-ID
	
	public function getSkey($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('skey','','string'); //default page is empty.
		//validation process
		$result = $this->sanitizeInput($result);
		return $result;		
	}
	
	public function getUscode($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('uscode','','string'); //default page is empty.
		//validation process
		$result = $this->sanitizeInput($result);
		return $result;		
	}
//prepare the sessions and user-ID - end
	
//get current page.
	public function getPage($id = 1) {		
		$jinput = JFACTORY::getApplication()->input;
		$page = $jinput->get('page',1,'int'); //default page is 1.
				
		//validation process
		$page = $this->sanitizeInput($page);
		$itemscount = $this->getItemscount();
		$itemsperpage = $this->getItemsperpage();
			
		// get from xml
		$maxpage = round(($itemscount / $itemsperpage) + 0.5,0,PHP_ROUND_HALF_DOWN);
		
		if($page < 1){$page = 1;}//default page is 1.
		if($page > $maxpage){$page = $maxpage;} //max is maxpage
		return $page;
	}

	
//get current maximum paging per screen.
	public function getMaxpaging($id = 1){
		$db = JFactory::getDbo();

		// get from xml
		$app = JFactory::getApplication();
		$params = $app->getParams();
		//$param = $app->input->get('limit', $params->get('maxpage', $param_default), 'uint');
				
		$result = $params->get('maxpage', 10);
		return $result;			
		//return $param;
	}

//count number of comments matching criteria, so it can be calculated for paging.
	public function getItemscount($id = 1) {
		// This function is to count eligible items. Results are returned to get the max page.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		
		$jinput = JFACTORY::getApplication()->input;
		$uscode = $jinput->get('uscode','','string'); //default page is empty.

		$db = JFactory::getDbo();
		
		$query = $db->getQuery(true);		
	
		$query->select($db->quoteName('a.uscode'));
		$query->select($db->quoteName('a.priv'));
		$query->select($db->quoteName('b.link_to_menu'));
		$query->select($db->quoteName('b.menu'));
		$query->select($db->quoteName('b.menu_desc'));
		$query->from($db->quoteName('#__ccauthlist', 'a')); // change when change table
		$query->join('LEFT', $db->quoteName('#__ccauthmenu', 'b') . ' ON (' . $db->quoteName('a.priv') . ' = ' . $db->quoteName('b.priv') . ')');
		$query->where($db->quoteName('uscode') . ' = '. $db->quote($uscode));
		$query->where($db->quoteName('b.link_to_menu') . ' != ""');
		
		$db->setQuery($query);
			 
		$results = $db->loadObjectList();	
		$itemscount = count($results);
		
		return $itemscount;
		}
	
		
//get configuration of items per page. Get it from database as default, get it from menu items when defined.
	public function getItemsperpage(){

		// get from xml if database is not set
		$app = JFactory::getApplication();
		$params = $app->getParams();

		// Get the pagination request variables
		//$itemsperpage = $app->input->get('limit', $params->get('maxitem', $itemsperpage_def), 'uint');
				
		$result = $params->get('maxitem',10);
		//return $itemsperpage;
		
		return $result;
		
		}

// now get the comments to be displayed, according to matching criteria.
	

	public function sanitizeInput($input){
	$input = trim($input);
	$input = stripslashes($input);
	$input = htmlspecialchars($input);
	return $input;
	}
	
	public function validateCompare($data, $validData){
	//This function to compare a string against valid data in arrays.
	$data = $this->sanitizeInput($data);
	//set default first
	$result = $validData[0];// set default result to first valid data if not found
	//compare, if found override result
		foreach ($validData as $testdata){
			if($testdata == $data ){				
			$result = $data; //override result
			}
		}
	return $result;
	}
	
	public function getOrdering($id = 1)
		{	
			$app = JFactory::getApplication();
			$params = $app->getParams();
			$order_default = $app->input->get('limit', $params->get('orderby_sec', 'inid'), 'uint');
			
			//new: override if set by user. dont forget to validate
			$jinput = JFACTORY::getApplication()->input;
			$order_type = $jinput->get('orderby',$order_default); //default get parameter

			$order_submit = $jinput->get('ordering_submit'); 
			if (isset($order_submit))
			{
			$order_type = $order_submit;
			}
			//validate $order_submit
			//set true data
			//$validDataOrdering = ['id','rid','date','rdate','name','rname'];
			$validDataOrdering = ['id','rid','name','rname'];
			
			$order_type = $this->validateCompare($order_type, $validDataOrdering);
						
			return $order_type;
		}
		
	public function getMenus($id = 1)
		{
		//check authority
		$valid = $this->getAuth();//authority check
	
		if($valid == 1){
			if (!isset($this->article[$id]))
			{			
		
			// get from xml
			$jinput = JFACTORY::getApplication()->input;

			//get the ordering
			$app = JFactory::getApplication();
			$params = $app->getParams();
			$order_type = $this->getOrdering();
			$jinput = JFACTORY::getApplication()->input;
			$skey = $jinput->get('skey','','string'); //default page is empty.
			$uscode = $jinput->get('uscode','','string'); //default page is empty.
	
			// get the comment items
			 
			// Create a new query object.
			
			$db = JFactory::getDbo();
			
			$query = $db->getQuery(true);		
			
			$query->select($db->quoteName('a.uscode'));
			$query->select($db->quoteName('a.priv'));
			$query->select($db->quoteName('a.id'));
			$query->select($db->quoteName('b.link_to_menu'));
			$query->select($db->quoteName('b.menu'));
			$query->select($db->quoteName('b.menu_desc'));
			$query->select($db->quoteName('b.task'));
			$query->select($db->quoteName('b.option'));
			$query->from($db->quoteName('#__ccauthlist', 'a')); // change when change table
			$query->join('LEFT', $db->quoteName('#__ccauthmenu', 'b') . ' ON (' . $db->quoteName('a.priv') . ' = ' . $db->quoteName('b.priv') . ')');
			$query->where($db->quoteName('uscode') . ' = '. $db->quote($uscode));
			$query->where($db->quoteName('b.link_to_menu') . ' != ""');
			$query->where($db->quoteName('b.published') . ' = 1'); // only view the menus, not action privileges.

			// Order it by the ordering field.
			$query->order('id ASC');			
			//$query->setLimit($itemsperpage,$skipitems);

			$db->setQuery($query);
			 
			$results = $db->loadObjectList();	

			}
		}
		if($valid == 0){ //authority check
			$results = array();
		}
		
		return $results;
	}
	
	public function getMsg($id = 1)
		{
		//check authority
		$valid = $this->getAuth();//authority check
	
		if($valid == 1){
			if (!isset($this->article[$id]))
			{			
			$itemsperpage = $this->getItemsperpage();
			
			// get from xml
			$jinput = JFACTORY::getApplication()->input;

			$page = $this->getPage();//get current page
			$skipitems = $itemsperpage * ($page - 1);

			//get the ordering
			$app = JFactory::getApplication();
			$params = $app->getParams();
			$order_type = $this->getOrdering();
			$jinput = JFACTORY::getApplication()->input;
			$skey = $jinput->get('skey','','string'); //default page is empty.
			$uscode = $jinput->get('uscode','','string'); //default page is empty.
			
			$db = JFactory::getDbo();
			
			$msg = $db->getQuery(true);		
			
			$msg->select($db->quoteName('a.uscode'));
			$msg->select($db->quoteName('a.priv'));
			$msg->select($db->quoteName('b.link_to_menu'));
			$msg->select($db->quoteName('b.menu'));
			$msg->select($db->quoteName('b.menu_desc'));
			$msg->from($db->quoteName('#__ccauthlist', 'a')); // change when change table
			$msg->join('LEFT', $db->quoteName('#__ccauthmenu', 'b') . ' ON (' . $db->quoteName('a.priv') . ' = ' . $db->quoteName('b.priv') . ')');
			$msg->where($db->quoteName('uscode') . ' = '. $db->quote($uscode));
			$msg->where($db->quoteName('b.link_to_menu') . ' != ""');
			// Order it by the ordering field.
			$msg->order('priv ASC');			
			$msg->setLimit($itemsperpage,$skipitems);

			$db->setQuery($msg);
			 
			$results = $db->loadObjectList();	

			}
		}
		if($valid == 0){ //authority check
			$results = array();
		}
			return $results;
	}
	
	
}