<?php

defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.model');

class CCpembelianModelNewPur extends JModelItem
{
	//to get back the id of article want to be commented.
	
/*************************  COMMON FUNCTIONS *****************************/

	public function sanitizeInput($input){
		$input = trim($input);
		$input = stripslashes($input);
		$input = htmlspecialchars($input);
		return $input;
	}
		

// AUTHORITY CHECK FUNCTIONS


	public function getAuthority() 
	{	
		$skey 	= $this->getSkey(); 
		$uscode = $this->getUscode(); 
		$priv_req = 'authall'; //required privilege
		$check = $this->getInstance('Home', 'CCpembelianModel')->home_check_priv($skey, $uscode, $priv_req); // this refer function in the home model.
		return $check;
		
	}

	public function getMenus($id = 1)
	{
		// get from xml
		$jinput = JFACTORY::getApplication()->input;

		//get the ordering
		$app = JFactory::getApplication();
		$params = $app->getParams();
		//$order_type = $this->getOrdering();
		$jinput = JFACTORY::getApplication()->input;
		$skey = $jinput->get('skey','','string'); //default page is empty.
		$uscode = $jinput->get('uscode','','string'); //default page is empty.

		// Create a new query object.
		
		$db = JFactory::getDbo();
		
		$query = $db->getQuery(true);		
		
		$query->select($db->quoteName('a.uscode'));
		$query->select($db->quoteName('a.priv'));
		$query->select($db->quoteName('a.id'));
		$query->select($db->quoteName('b.link_to_menu'));
		$query->select($db->quoteName('b.menu'));
		$query->select($db->quoteName('b.menu_desc'));
		$query->select($db->quoteName('b.task'));
		$query->select($db->quoteName('b.option_s'));
		$query->from($db->quoteName('#__ccauthlist', 'a')); // change when change table
		$query->join('LEFT', $db->quoteName('#__ccauthmenu', 'b') . ' ON (' . $db->quoteName('a.priv') . ' = ' . $db->quoteName('b.priv') . ')');
		$query->where($db->quoteName('uscode') . ' = '. $db->quote($uscode));
		$query->where($db->quoteName('b.link_to_menu') . ' != ""');
		$query->where($db->quoteName('b.published') . ' = 1'); // only view the menus, not action privileges.

		// Order it by the ordering field.
		$query->order('id ASC');
		$db->setQuery($query);			 
		$results = $db->loadObjectList();	

		return $results;
	}

	public function getValueWithLimit($field, $table, $where, $value, $ordering, $by, $limit)
	{
		$db = JFactory::getDbo();
		$query = $db
			->getQuery(true)
			->select($field)
			->from($db->quoteName($table))
			->where($db->quoteName($where) . " = " . $db->quote($value))
			->order($db->quoteName($ordering) . $by)
			->setLimit($limit);
		$db->setQuery($query);
		return $db->loadRowList();
	}
/*****************  GETTING THE DATA TO DETERMINE HOW THE PAGE LOOKS *******************/
	
	public function getSkey() {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('skey','','string'); //default page is empty.
		$result = $this->sanitizeInput($result);
		return $result;		
	}
	
	public function getUscode() {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('uscode','','string'); //default page is empty.
		$result = $this->sanitizeInput($result);
		return $result;		
	}
	
/*****************  GETTING DATA FOR FORM VALIDATIONS *******************/

//get vendor
	function getVendor($id=1) {
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName(array('vendorid','name'))); //change field
		$query->from($db->quoteName('#__ccpurvendor')); // change when change table
		// here is the matching criteria:  
		$query->where($db->quoteName('status') . ' = '. $db->quote('1'));		 
		$db->setQuery($query);
		$results = $db->loadRowList();
		return $results;
	}
	
	
	function getGlid($id=1) {

		// This function is to get eligible items as arrays.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName(array('glid','glname'))); //change field
		$query->from($db->quoteName('#__ccworldgl')); // change when change table
		// here is the matching criteria:  
		$query->where($db->quoteName('status') . ' = '. $db->quote('1'));
		 
		$db->setQuery($query);
		$results = $db->loadRowList();
		
		return $results;
	}
	
	//get item to be bought
	function getInvemaster($id=1) {
		// This function is to get eligible items as arrays.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName(array('itemcode','name','itemdesc'))); //change field
		$query->from($db->quoteName('#__ccinvemaster')); // change when change table
		// here is the matching criteria:  
		//$query->where($db->quoteName('status') . ' = '. $db->quote('1'));
		 
		$db->setQuery($query);
		$results = $db->loadRowList();
		
		return $results;
	}
	
	//get warehouse to be set as destination
	function getWarehouse($id=1) {		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName(array('enid','enname'))); //change field
		$query->from($db->quoteName('#__ccwarehousemaster')); // change when change table
		// here is the matching criteria:  
		//$query->where($db->quoteName('status') . ' = '. $db->quote('1'));
		$query->where($db->quoteName('supplier') . ' <> '. $db->quote('1'));
		$query->where($db->quoteName('customer') . ' <> '. $db->quote('1'));

		$db->setQuery($query);
		$results = $db->loadRowList();
		
		return $results;
	}
	
	//get last 5 purchase ID as information

	function getRefs()
	{
		return $this->getValueWithLimit('id', '#__ccpurctrx', 'status', 1, 'jndate', ' DESC', 5 );
	}
	
	function getPos()
	{
		$fields = array('jnref','jndate','description');
		return $this->getValueWithLimit($fields, '#__ccpurctrx', 'status', 1, 'jndate', ' DESC', 2 );
	}
	
}
?>