<?php
/**
 Purreceive is used to receive purchased materials once ordered in the system.
 The view should display warehouses available to the users to receive ordered goods.
 If no warehouse assigned then show info to user that no warehouse available to manage, or you dont have the authority.
 
 */
 
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

class CCpembelianModelPurreceive extends JModelItem
{
	protected $messages;

/*************************  COMMON FUNCTIONS *****************************/

	public function sanitizeInput($input){
		$input = trim($input);
		$input = stripslashes($input);
		$input = htmlspecialchars($input);
		return $input;
		}
		
	public function validateCompare($data, $validData){
		//This function to compare a string against valid data in arrays.
		$data = $this->sanitizeInput($data);
		//set default first
		$result = $validData[0];// set default result to first valid data if not found
		//compare, if found override result
			foreach ($validData as $testdata){
				if($testdata == $data ){				
				$result = $data; //override result
				}
			}
		return $result;
		}

/********************  AUTHORITY CHECK FUNCTIONS *************************/


	public function getAuth() 
	{	
		$skey 	= $this->getSkey(); 
		$uscode = $this->getUscode(); 
		$priv_req = 'authall'; //required privilege
		$check = $this->getInstance('Home', 'CCpembelianModel')->home_check_priv($skey, $uscode, $priv_req); // this refer function in the home model.
		return $check;
	}

/*****************  GETTING THE DATA TO DETERMINE HOW THE PAGE LOOKS *******************/
	
	public function getSkey($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('skey','','string'); //default page is empty.
		return $this->sanitizeInput($result);	
	}
	
	public function getUscode($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('uscode','','string'); //default page is empty. $this->sanitizeInput($result);
		return $this->sanitizeInput($result);	
	}
	
	public function getUsid($id = 1) {		//authority check
		//$usid = $this->getSomeRows('usid', '#__ccauthsession', 'passwrd',$this->getUscode);
		//validate if found
		
		//return $result;	
		$skey = $this->getSkey();
		//$uscode = "e2ef7b61bb37ac19c020f5100ed6df202bec0424";
		$db = JFactory::getDbo();
		$query = $db
		->getQuery(true)
		->select('usid')
		->from($db->quoteName('#__ccauthsession')) // change when change table
		->where($db->quoteName('passwrd') . ' = '.$db->quote($skey));
		
		$db->setQuery($query);
		$result = $db->loadResult();
		
		if(empty($skey)){
			return "";
		}
		else{
			return $result;
		}		
	}

	public function getSomeRows($select, $table, $where="", $ins="", $ordering="", $by="") {
		// This function is to get eligible items as arrays.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($select); //array
		$query->from($db->quoteName($table)); // change when change table
		// here is the matching criteria:  
	 	if($where!=""){
			$query->where($db->quoteName($where) . ' = '. $db->quote($ins));
		}
	 	if($ordering!=""){
			$query->order($db->quote($ordering.$by));
		}
		$db->setQuery($query);
		$result = $db->loadObjectList();
		
		return $result;
	}

	public function getMenus($id = 1){
		$valid = $this->getAuth();//authority check
		$uscode = $this->getUscode(); 
		
		if($valid == 1)
		{
			$results = $this->getInstance('Home', 'CCpembelianModel')->home_get_menus($uscode);
		} else { 
			$results = array(); //return empty array when no menu found for the user.
		}
		return $results;
	}
	////////////// GET LIST for THIS PAGE////////////////
	public function getList(){	
		$usid = $this->getUsid();
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select(array('a.enid','b.enname','b.endesc')); //array
		$query->from($db->quoteName('#__ccwarehouseauth', 'a')); // change when change table
		$query->join('LEFT', $db->quoteName('#__ccwarehousemaster', 'b') . ' ON ' . $db->quoteName('a.enid') . ' = ' . $db->quoteName('b.enid'));

		// here is the matching criteria:  
		//$query->where($db->quoteName('a.status') . ' = 1');	
		$query->where($db->quoteName('a.usid') .' = '. $db->quote($usid)) ; 
		
	 	$query->order('b.enname ASC');
		
		$db->setQuery($query);
		$result = $db->loadObjectList();
		
		return $result;
	}
	
	public function getItems(){	
		$usid = $this->getUsid();
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select(array('a.enid','b.enname','c.status','c.ref','c.itemcode','c.vendor','c.jnref','c.jndate','c.qc','c.quantity','c.received','c.retur','c.price')); //array
		$query->from($db->quoteName('#__ccwarehouseauth', 'a')); // change when change table
		$query->join('LEFT', $db->quoteName('#__ccwarehousemaster', 'b') . ' ON ' . $db->quoteName('a.enid') . ' = ' . $db->quoteName('b.enid'));
		$query->join('INNER', $db->quoteName('#__ccpurcdetail', 'c') . ' ON ' . $db->quoteName('c.warehouse') . ' = ' . $db->quoteName('b.enid'));

		// here is the matching criteria:  
		$query->where($db->quoteName('a.usid') .' = '. $db->quote($usid)) ; //$db->quote($this->getUsid()));	

	 	$query->order('b.enname ASC');
		
		$db->setQuery($query);
		$result = $db->loadObjectList();
		
		return $result;
	}
	
	
	
}