<?php
 
defined('_JEXEC') or die('Restricted access');

class CCjournalModelJournals extends JModelItem //change component
{
	protected $messages;

	public function getTable($type = 'CCjournal', $prefix = 'CCjournalTable', $config = array()) //cc notes: prefix can be changed consistent with file ccworld content. Type should consistent with both class name and file name.
	{
		return JTable::getInstance($type, $prefix, $config);
	}
 

//validate the user first
	public function getAuth($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$skey = $jinput->get('skey','','string'); //default page is empty.
		$uscode = $jinput->get('uscode','','string'); //default page is empty.
		$priv_req = 'authall'; //required privilege
				
		//validation process
		$skey = $this->sanitizeInput($skey);
			
		// query if found
			function getUsid($skey, $uscode, $priv_req) {
	
					$db = JFactory::getDbo();
					$query = $db->getQuery(true);
					$query->select($db->quoteName('a.uscode')); //change field
					$query->from($db->quoteName('#__ccauthsession', 'a')); // change when change table
					$query->join('RIGHT', $db->quoteName('#__ccauthlist', 'b') . ' ON (' . $db->quoteName('a.uscode') . ' = ' . $db->quoteName('b.uscode') . ')');
					// here is the matching criteria:  
					$query->where($db->quoteName('passwrd') . ' = '. $db->quote($skey));
					$query->where($db->quoteName('b.priv') . ' = '. $db->quote($priv_req));//this is the privilege
					$query->where($db->quoteName('b.uscode') . ' = '. $db->quote($uscode));//this is the privilege
					$db->setQuery($query);
					$results = $db->loadResult(); //single data query
					
					return $results;
			}
			
		$check = getUsid($skey, $uscode, $priv_req);
		
		if($check!=""){
			$valid = 1;
			}
			else {
			$valid = 0;
			}
			
		return $valid;
	}

	
	public function getSkey($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('skey','','string'); //default page is empty.
		//validation process
		$result = $this->sanitizeInput($result);
		return $result;		
	}
 
//get current page.
	public function getPage($id = 1) {		
		$jinput = JFACTORY::getApplication()->input;
		$page = $jinput->get('page',1,'int'); //default page is 1.
				
		//validation process
		$page = $this->sanitizeInput($page);
		$itemscount = $this->getItemscount();
		$itemsperpage = $this->getItemsperpage();
			
		// get from xml
		$maxpage = round(($itemscount / $itemsperpage) + 0.5,0,PHP_ROUND_HALF_DOWN);
		
		if($page < 1){$page = 1;}//default page is 1.
		if($page > $maxpage){$page = $maxpage;} //max is maxpage
		return $page;
	}

	
//get current maximum paging per screen.
	public function getMaxpaging($id = 1){
	
		// get from xml
		$app = JFactory::getApplication();
		$params = $app->getParams();
//		$param = $app->input->get('limit', $params->get('maxpage', $param_default), 'uint');
				
		$test= $params->get('maxpage', 10);
		return $test;			
		//return $param;
	}

//count number of comments matching criteria, so it can be calculated for paging.
	public function getItemscount($id = 1) {
		// This function is to count eligible items. Results are returned to get the max page.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName('jnid')); //change field
		$query->from($db->quoteName('#__ccjourntrx')); // change when change table
		// here is the matching criteria:  
		$query->where($db->quoteName('status') . ' = '. $db->quote('1'));
		 
		$db->setQuery($query);
		$query = $db->loadObjectList();
		$itemscount = count($query);
		
		return $itemscount;
		}
	
			
//get configuration of items per page. Get it from database as default, get it from menu items when defined.
	public function getItemsperpage(){
		//get items per page from database.
		$db = JFactory::getDbo();
		
		// get from xml if database is not set
		$app = JFactory::getApplication();
		$params = $app->getParams();

		// Get the pagination request variables
	//	$itemsperpage = $app->input->get('limit', $params->get('maxitem', $itemsperpage_def), 'uint');
				
		$test = $params->get('maxitem',10);
		//return $itemsperpage;
		
		return $test;
		}

// now get the comments to be displayed, according to matching criteria.
	

	public function sanitizeInput($input){
	$input = trim($input);
	$input = stripslashes($input);
	$input = htmlspecialchars($input);
	return $input;
	}
	
	public function validateCompare($data, $validData){
	//This function to compare a string against valid data in arrays.
	$data = $this->sanitizeInput($data);
	//set default first
	$result = $validData[0];// set default result to first valid data if not found
	//compare, if found override result
		foreach ($validData as $testdata){
			if($testdata == $data ){				
			$result = $data; //override result
			}
		}
	return $result;
	}
	
	public function getOrdering($id = 1)
		{			
			$app = JFactory::getApplication();
			$params = $app->getParams();
			$order_default = $app->input->get('limit', $params->get('orderby_sec', 'jnid'), 'uint'); //change field
			
			//new: override if set by user. dont forget to validate
			$jinput = JFACTORY::getApplication()->input;
			$order_type = $jinput->get('orderby',$order_default); //default get parameter

			$order_submit = $jinput->get('ordering_submit'); 
			if (isset($order_submit))
			{
			$order_type = $order_submit;
			}
			//validate $order_submit
			//set true data
			$validDataOrdering = ['id','rid','date','rdate'];
			
			
			$order_type = $this->validateCompare($order_type, $validDataOrdering);
						
			return $order_type;
		}
		
	public function getMsg($id = 1)
		{
			
		if (!isset($this->article[$id]))
		{			
			$itemsperpage = $this->getItemsperpage();
			
			// get from xml
			$jinput = JFACTORY::getApplication()->input;

			$page = $this->getPage();//get current page
			
			$skipitems = $itemsperpage * ($page - 1);

			//get the ordering
			$app = JFactory::getApplication();
			$params = $app->getParams();
			$order_type = $this->getOrdering();
			
			switch ($order_type){
			case 'date':
				$ordering = 'jndate ASC';
				break;
			case 'rdate':
				$ordering = 'jndate DESC';
				break;
			
			case 'id':
				$ordering = 'jnid ASC';
				break;
			case 'rid':
				$ordering = 'jnid DESC';
				break;
			default: 
				$ordering = 'jnid ASC';
				break;
			}

			
			// get the comment items
			 
			// Create a new query object.
			
			$db = JFactory::getDbo();
			
			$query = $db->getQuery(true);		

			//load all the jnids
			$query->select($db->quoteName('jnid'));
			$query->from($db->quoteName('#__ccjourntrx'));//change database
			$query->where($db->quoteName('status') . ' = '. $db->quote('1'));
			// Order it by the ordering field.
			$query->order($ordering);			
			$query->setLimit($itemsperpage,$skipitems);
			$db->setQuery($query);
			$ids = $db->loadColumn();	
			 
			//check 
			
			$new = array();
			
			foreach($ids as $id){
			$query2 = $db->getQuery(true);	
			$query2->select($db->quoteName(array('a.jnid','a.jndate','a.description','b.glid','b.dbcr','b.nominal','c.glname')));
			$query2->from($db->quoteName('#__ccjourntrx', 'a'));//change database
			$query2->join('INNER', $db->quoteName('#__ccjourn', 'b') . ' ON (' . $db->quoteName('b.jnid') . ' = ' . $db->quoteName('a.jnid') . ')');
			$query2->join('LEFT', $db->quoteName('#__ccworldgl', 'c') . ' ON (' . $db->quoteName('c.glid') . ' = ' . $db->quoteName('b.glid') . ')');
			$query2->where($db->quoteName('a.jnid') . ' = '. $id);
			$db->setQuery($query2);
			$new[] = $db->loadObjectList();
			
			
			
			}
			
			
			/*
			foreach($ids as $id){
			//check
		//	$query->select($db->quoteName(array('a.id', 'a.article_id', 'a.date', 'a.message', 'a.name','a.email')));
			$query->select($db->quoteName(array('a.jndate','a.description')));
			//$query->select($db->quoteName('b.glid','b.dbcr','b.nominal'));
			$query->from($db->quoteName('#__ccjourntrx', 'a'));//change database
			//$query->join('RIGHT', $db->quoteName('#__ccjourn', 'b') . ' ON (' . $db->quoteName('b.jnid') . ' = ' . $db->quoteName('a.jnid') . ')');
			$query->where($db->quoteName('a.status') . ' = '. $db->quote('1'));
			$query->where($db->quoteName('a.jnid') . ' = 1' );

			// Order it by the ordering field.
			//$query->order($ordering);			
			//$query->setLimit($itemsperpage,$skipitems);

			$db->setQuery($query);
			$results = $db->loadObjectList();
			$new[] = $results;
			 }
			 */

		}
		return $new;
	}
	

	
	
	
	
}